"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FlatList = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _ScrollView = require("./ScrollView");

var _usePrerenderedData = require("./hooks/usePrerenderedData");

var _config = require("./config");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const maintainVisibleContentPosition = {
  minIndexForVisible: _config.MIN_INDEX
};
const FlatListImpl = /*#__PURE__*/(0, _react.forwardRef)((props, ref) => {
  const renderScrollComponent = (0, _react.useCallback)(props => {
    return /*#__PURE__*/_react.default.createElement(_ScrollView.ScrollView, props);
  }, []);
  const capturedRef = (0, _react.useRef)();
  const captureRef = (0, _react.useCallback)(r => {
    const obj = r ? Object.assign(r, {
      shift: options => {
        if (_reactNative.Platform.OS !== 'android') {
          return;
        }

        r.getNativeScrollRef().shift(options);
      }
    }) : r;
    capturedRef.current = obj;

    if (!ref) {
      return;
    }

    if (typeof ref === 'function') {
      ref(obj);
    } else {
      ref.current = obj;
    }
  }, [ref]); // todo add hack to prevent flickering

  const {
    data = [],
    keyExtractor = item => item.id ?? item.key,
    renderItem,
    onUpdateData,
    getItemLayout,
    onLayout
  } = props;
  const {
    finalData,
    prerender,
    getItemLayoutCustom
  } = (0, _usePrerenderedData.usePrerenderedData)({
    data: data ?? [],
    keyExtractor,
    renderItem,
    scrollRef: capturedRef,
    onUpdateData,
    getItemLayout
  });
  const [width, setWidth] = (0, _react.useState)();
  const onLayoutFlatList = (0, _react.useCallback)(e => {
    onLayout === null || onLayout === void 0 ? void 0 : onLayout(e);
    setWidth(e.nativeEvent.layout.width);
  }, [onLayout]);
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_reactNative.FlatList, _extends({
    maintainVisibleContentPosition: props.maintainVisibleContentPosition ?? maintainVisibleContentPosition,
    renderScrollComponent: _reactNative.Platform.OS === 'android' ? renderScrollComponent : undefined,
    getItemLayout: getItemLayoutCustom
  }, props, {
    onLayout: onLayoutFlatList,
    data: finalData,
    ref: captureRef
  })), prerender && !!width && /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: [styles.prerender, {
      width
    }]
  }, prerender));
});

const styles = _reactNative.StyleSheet.create({
  prerender: {
    position: 'absolute',
    top: 0,
    left: -10000
  }
});

const FlatList = FlatListImpl;
exports.FlatList = FlatList;
//# sourceMappingURL=FlatList.js.map