"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ScrollViewComponent = exports.ScrollView = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _BidirectionalFlatlist = require("./BidirectionalFlatlist");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// eslint-disable-next-line @typescript-eslint/ban-ts-comment
// @ts-ignore
const ScrollViewRNRaw = _reactNative.ScrollView.render().type; // hack to get inner type of ScrollView


class ScrollViewComponent extends ScrollViewRNRaw {
  constructor(props) {
    super(props);

    _defineProperty(this, "shift", _ref => {
      let {
        offset,
        height
      } = _ref;
      this.getNativeScrollRef().setNativeProps({
        shiftOffset: _reactNative.PixelRatio.getPixelSizeForLayoutSize(offset),
        shiftHeight: _reactNative.PixelRatio.getPixelSizeForLayoutSize(height)
      });
    });
  }

  render() {
    const NativeDirectionalScrollView = _BidirectionalFlatlist.BidirectionalFlatlist;
    const NativeDirectionalScrollContentView = _reactNative.View;
    const contentContainerStyle = [this.props.contentContainerStyle]; // if (__DEV__ && this.props.style !== undefined) {
    // const style = StyleSheet.flatten(this.props.style);
    // const childLayoutProps = ['alignItems', 'justifyContent'].filter(
    //   (prop) => style && style[prop] !== undefined
    // );
    // invariant(
    //   childLayoutProps.length === 0,
    //   'ScrollView child layout (' +
    //     JSON.stringify(childLayoutProps) +
    //     ') must be applied through the contentContainerStyle prop.'
    // );
    // }

    const contentSizeChangeProps = this.props.onContentSizeChange == null ? null : {
      onLayout: this._handleContentOnLayout
    };
    const {
      stickyHeaderIndices
    } = this.props;
    const children = this.props.children;
    const hasStickyHeaders = Array.isArray(stickyHeaderIndices) && stickyHeaderIndices.length > 0;

    const contentContainer = /*#__PURE__*/_react.default.createElement(NativeDirectionalScrollContentView, _extends({}, contentSizeChangeProps, {
      ref: this._setInnerViewRef,
      style: contentContainerStyle,
      removeClippedSubviews: // Subview clipping causes issues with sticky headers on Android and
      // would be hard to fix properly in a performant way.
      _reactNative.Platform.OS === 'android' && hasStickyHeaders ? false : this.props.removeClippedSubviews,
      collapsable: false
    }), children);

    const alwaysBounceHorizontal = this.props.alwaysBounceHorizontal !== undefined ? this.props.alwaysBounceHorizontal : this.props.horizontal;
    const alwaysBounceVertical = this.props.alwaysBounceVertical !== undefined ? this.props.alwaysBounceVertical : !this.props.horizontal;
    const baseStyle = styles.baseVertical;
    const props = { ...this.props,
      alwaysBounceHorizontal,
      alwaysBounceVertical,
      style: _reactNative.StyleSheet.compose(baseStyle, this.props.style),
      // Override the onContentSizeChange from props, since this event can
      // bubble up from TextInputs
      onContentSizeChange: null,
      onLayout: this._handleLayout,
      onMomentumScrollBegin: this._handleMomentumScrollBegin,
      onMomentumScrollEnd: this._handleMomentumScrollEnd,
      onResponderGrant: this._handleResponderGrant,
      onResponderReject: this._handleResponderReject,
      onResponderRelease: this._handleResponderRelease,
      onResponderTerminationRequest: this._handleResponderTerminationRequest,
      onScrollBeginDrag: this._handleScrollBeginDrag,
      onScrollEndDrag: this._handleScrollEndDrag,
      onScrollShouldSetResponder: this._handleScrollShouldSetResponder,
      onStartShouldSetResponder: this._handleStartShouldSetResponder,
      onStartShouldSetResponderCapture: this._handleStartShouldSetResponderCapture,
      onTouchEnd: this._handleTouchEnd,
      onTouchMove: this._handleTouchMove,
      onTouchStart: this._handleTouchStart,
      onTouchCancel: this._handleTouchCancel,
      onScroll: this._handleScroll,
      scrollEventThrottle: hasStickyHeaders ? 1 : this.props.scrollEventThrottle,
      sendMomentumEvents: this.props.onMomentumScrollBegin || this.props.onMomentumScrollEnd ? true : false,
      // default to true
      snapToStart: this.props.snapToStart !== false,
      // default to true
      snapToEnd: this.props.snapToEnd !== false,
      // pagingEnabled is overridden by snapToInterval / snapToOffsets
      pagingEnabled: _reactNative.Platform.select({
        // on iOS, pagingEnabled must be set to false to have snapToInterval / snapToOffsets work
        ios: this.props.pagingEnabled === true && this.props.snapToInterval == null && this.props.snapToOffsets == null,
        // on Android, pagingEnabled must be set to true to have snapToInterval / snapToOffsets work
        android: this.props.pagingEnabled === true || this.props.snapToInterval != null || this.props.snapToOffsets != null
      })
    }; // const { decelerationRate } = this.props;
    // if (decelerationRate != null) {
    //   props.decelerationRate = processDecelerationRate(decelerationRate);
    // }

    const scrollViewRef = this._scrollView.getForwardingRef(this.props.scrollViewRef);

    return /*#__PURE__*/_react.default.createElement(NativeDirectionalScrollView, _extends({}, props, {
      maintainVisibleContentPosition: undefined,
      ref: scrollViewRef
    }), contentContainer);
  }

}

exports.ScrollViewComponent = ScrollViewComponent;

const styles = _reactNative.StyleSheet.create({
  baseVertical: {
    flexGrow: 1,
    flexShrink: 1,
    flexDirection: 'column',
    overflow: 'scroll'
  }
});

const ScrollView = /*#__PURE__*/(0, _react.forwardRef)((props, ref) => {
  return /*#__PURE__*/_react.default.createElement(ScrollViewComponent, _extends({}, props, {
    ref: ref
  }));
});
exports.ScrollView = ScrollView;
//# sourceMappingURL=ScrollView.js.map