function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React, { forwardRef, useCallback, useRef, useState } from 'react';
import { FlatList as FlatListRN, Platform, StyleSheet, View } from 'react-native';
import { ScrollView } from './ScrollView';
import { usePrerenderedData } from './hooks/usePrerenderedData';
import { MIN_INDEX } from './config';
const maintainVisibleContentPosition = {
  minIndexForVisible: MIN_INDEX
};
const FlatListImpl = /*#__PURE__*/forwardRef((props, ref) => {
  const renderScrollComponent = useCallback(props => {
    return /*#__PURE__*/React.createElement(ScrollView, props);
  }, []);
  const capturedRef = useRef();
  const captureRef = useCallback(r => {
    const obj = r ? Object.assign(r, {
      shift: options => {
        if (Platform.OS !== 'android') {
          return;
        }

        r.getNativeScrollRef().shift(options);
      }
    }) : r;
    capturedRef.current = obj;

    if (!ref) {
      return;
    }

    if (typeof ref === 'function') {
      ref(obj);
    } else {
      ref.current = obj;
    }
  }, [ref]); // todo add hack to prevent flickering

  const {
    data = [],
    keyExtractor = item => item.id ?? item.key,
    renderItem,
    onUpdateData,
    getItemLayout,
    onLayout
  } = props;
  const {
    finalData,
    prerender,
    getItemLayoutCustom
  } = usePrerenderedData({
    data: data ?? [],
    keyExtractor,
    renderItem,
    scrollRef: capturedRef,
    onUpdateData,
    getItemLayout
  });
  const [width, setWidth] = useState();
  const onLayoutFlatList = useCallback(e => {
    onLayout === null || onLayout === void 0 ? void 0 : onLayout(e);
    setWidth(e.nativeEvent.layout.width);
  }, [onLayout]);
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(FlatListRN, _extends({
    maintainVisibleContentPosition: props.maintainVisibleContentPosition ?? maintainVisibleContentPosition,
    renderScrollComponent: Platform.OS === 'android' ? renderScrollComponent : undefined,
    getItemLayout: getItemLayoutCustom
  }, props, {
    onLayout: onLayoutFlatList,
    data: finalData,
    ref: captureRef
  })), prerender && !!width && /*#__PURE__*/React.createElement(View, {
    style: [styles.prerender, {
      width
    }]
  }, prerender));
});
const styles = StyleSheet.create({
  prerender: {
    position: 'absolute',
    top: 0,
    left: -10000
  }
});
export const FlatList = FlatListImpl;
//# sourceMappingURL=FlatList.js.map