import type { ReactNode } from 'react';
import type { FlatList as FlatListRN, FlatListProps } from 'react-native';
export declare type RenderItem = <T>(options: {
    item: T;
    prerendering?: boolean;
}) => ReactNode;
export declare type OnUpdateData = (options: {
    heights: Record<string, number>;
    offset: number;
    height: number;
}) => void;
export declare type ShiftFunction = ({ offset, height }: {
    offset: number;
    height: number;
}) => void;
export declare type FlatListType = typeof FlatListRN & {
    shift: ShiftFunction;
};
export declare type KeyExtractor = <T>(item: T) => string;
export declare type BidirectionalFlatListProps = FlatListProps<any> & {
    renderItem: RenderItem;
    onUpdateData?: OnUpdateData;
    keyExtractor: KeyExtractor;
};
